﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.3
@EndOfDesignText@
Sub Class_Globals
	Public MySprite As Sprite
	Private xui As XUI
	Private TempBC As BitmapCreator
	Private RemoveRowFrames As List
	Private BlockSize As Int
End Sub

Public Sub Initialize (Sprite1 As Sprite)
	MySprite = Sprite1
	BlockSize = MySprite.mGame.BlockSize
	Dim Frame As BitmapCreator
	Frame.Initialize(MySprite.Utils.MainBC.mWidth, MySprite.Utils.MainBC.mHeight)
	Frame.FillRect(xui.Color_Transparent, Frame.TargetRect)
	MySprite.Frame = Frame
	MySprite.SkipBlending = False
	MySprite.SrcRect = Frame.TargetRect
	'will be used to move parts of the background
	TempBC.Initialize(MySprite.Frame.mWidth, MySprite.Frame.mHeight)
	CreateRemoveRowBC
End Sub

Private Sub CreateRemoveRowBC
	Dim bc1 As BitmapCreator
	bc1.Initialize(MySprite.Frame.mWidth * 2, BlockSize)
	Dim r As B4XRect
	r.Initialize(bc1.mWidth / 2, 0, bc1.mWidth, bc1.mHeight)
	bc1.FillGradient(Array As Int(0xFFDA7000, 0xFFDA1800), r, "RIGHT_LEFT")
	r.Left = 0
	r.Width = bc1.mWidth / 2
	bc1.FillRect(xui.Color_Black, r)
	RemoveRowFrames = Array(bc1)
End Sub

Public Sub Tick (gs As GameStep)
	'nothing to see
End Sub


Public Sub RemoveRows (rows As List)
	Dim bc As BitmapCreator = MySprite.Frame
	Dim r As B4XRect
	Dim ttl As Int = MySprite.mGame.IntervalBetweenMovements * 2
	r.Initialize(0, 0, bc.mWidth, BlockSize * rows.Size)
	Dim offset As Int = BlockSize * rows.Size
	For i = 0 To MySprite.mGame.NumberOfRows - 1
		If rows.IndexOf(i) > -1 Then
			offset = offset - BlockSize
			Dim ds As DummySprite
			ds.Initialize(MySprite.Utils.CreateSprite(ds), RemoveRowFrames)
			ds.MySprite.Position.y = (i + 0.5) * BlockSize
			ds.MySprite.Position.x = -ds.MySprite.Frame.mWidth / 2 + 1
			ds.MySprite.SkipBlending = True
			Dim tp As GamePosition
			tp.y = ds.MySprite.Position.y
			tp.x = bc.mWidth
			ds.MySprite.TimeToLive = ttl
			ds.MySprite.Velocity = ds.MySprite.VelocityRequiredToReachPosition(tp, ttl)
			If Rnd(0, 2) = 1 Then
				ds.MySprite.Transformed = True
				ds.MySprite.Degrees = 180
				ds.MySprite.Velocity.vx = -ds.MySprite.Velocity.vx
				ds.MySprite.Position.x = ds.MySprite.Frame.mWidth / 2 + bc.mWidth - 1
			End If
		Else
			r.Top = i * BlockSize
			r.Height = BlockSize
			TempBC.DrawBitmapCreator(bc, r, 0, r.Top + offset, True)
		End If
	Next
	MySprite.Utils.AddFutureTask(Me, "DrawUpdatedScreen_AfterRemoval", ttl, Null)
End Sub

Private Sub DrawUpdatedScreen_AfterRemoval (ft As FutureTask)
	MySprite.Frame.DrawBitmapCreator(TempBC, TempBC.TargetRect, 0, 0, True)
End Sub