﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.3
@EndOfDesignText@
Sub Class_Globals
	Public MySprite As Sprite
	Private pd As PieceData
	Private BlockSize As Int
	Private orientation As Int = 0
	Private xui As XUI
	Public Moving As Boolean
	Private CenterPositionX, CenterPositionY As Int
	Private blocks As List
End Sub

Public Sub Initialize (Sprite1 As Sprite, Data As PieceData) As Boolean
	MySprite = Sprite1
	MySprite.SkipBlending = False
	BlockSize = MySprite.mGame.BlockSize
	MySprite.Frame.Initialize(4 * BlockSize, 4 * BlockSize)
	MySprite.SrcRect = MySprite.Frame.TargetRect
	blocks.Initialize
	pd = Data
	UpdatePattern
	MySprite.TickInterval = 10
	Dim StartY As Int = 0
	For Each xy() As Int In pd.Pattern
		If xy(1) = -1 Then StartY = 1
	Next
	If CanMove(5, StartY) = False Then
		 'game over!!!
		 CenterPositionX = 5
		CenterPositionY = StartY
		 UpdateGamePosition
		 Return False
	End If
	Move(5, StartY, True)
	Return True
End Sub

Private Sub UpdateGamePosition
	'translate between the blocks position to the game position
	MySprite.Position.x = CenterPositionX * BlockSize - pd.CenterX * BlockSize + MySprite.Frame.TargetRect.Width / 2
	MySprite.Position.y = CenterPositionY * BlockSize - pd.CenterY * BlockSize + MySprite.Frame.TargetRect.Height / 2
End Sub

Public Sub Tick (gs As GameStep)
	Dim dx As Int
	If Main.LeftDown Then
		dx = -1
		Main.LeftDown = False
	Else if Main.RightDown Then
		dx = 1
		Main.RightDown = False
	End If
	If dx <> 0 Then 
		Move(dx, 0, False)
	End If
	If Main.UpDown Then
		Main.UpDown = False
		'rotate
		Remove
		orientation = (orientation + 1) Mod pd.Orientations
		UpdatePattern
		If CanMove(0, 0) = True Then
			Move(0, 0, True)
		Else if CanMove(1, 0) Then
			Move(1, 0, True)
		Else if CanMove(-1, 0) Then
			Move(-1, 0, True)
		Else
			orientation = (orientation - 1 + pd.Orientations) Mod pd.Orientations
			UpdatePattern
			Move(0, 0, True)
		End If
	End If
	If MySprite.Index Mod MySprite.mGame.IntervalBetweenMovements = 0 Or Main.DownDown Then
		Dim dy As Int = 1
		If Main.DownDown And (xui.IsB4A Or xui.IsB4i) Then
			'move as far as possible
			Remove
			For i = 2 To 20
				If CanMove(0, i) = False Then
					dy = i - 1
					Exit
				End If
			Next
			Move(0, 0, True) 'put back
		End If
		Main.DownDown = False
		If Move(0, dy, False) Then
			'moved
		Else
			MySprite.mGame.PieceStoppedMoving(Me)
			MySprite.Delete(gs)
		End If
	End If
End Sub



Private Sub Remove
	For Each b() As Int In blocks
		Dim RowNumber As Int = b(1) + CenterPositionY
		Dim Column As Int = b(0) + CenterPositionX
		MySprite.mGame.SetTaken(Column, RowNumber, False)
	Next
End Sub

Private Sub Move (dx As Int, dy As Int, onlyset As Boolean) As Boolean
	If Not(onlyset) Then
		'remove
		Remove		
	End If
	If Not(onlyset) And CanMove(dx, dy) = False Then
		'cannot move so return previous state
		Move(0, 0, True)
		Return False
	End If
	CenterPositionX = CenterPositionX + dx
	CenterPositionY = CenterPositionY + dy
	For Each b() As Int In blocks
		Dim RowNumber As Int = b(1) + CenterPositionY 
		Dim Column As Int = b(0) + CenterPositionX
		MySprite.mGame.SetTaken(Column, RowNumber, True)
	Next
	UpdateGamePosition
	Return True
End Sub

Private Sub CanMove (dx As Int, dy As Int) As Boolean
	For Each b() As Int In blocks
		Dim RowNumber As Int = b(1) + CenterPositionY + dy
		Dim Column As Int = b(0) + CenterPositionX + dx
		If Column < 0 Or Column >= MySprite.mGame.BlocksPerRow Then Return False
		If RowNumber < 0 Or RowNumber >= MySprite.mGame.NumberOfRows Then Return False
		If MySprite.mGame.IsTaken(Column, RowNumber) Then Return False
	Next
	Return True
End Sub


Private Sub UpdatePattern
	MySprite.Frame.FillRect(xui.Color_Transparent, MySprite.Frame.TargetRect)
	blocks.Clear
	For Each p() As Int In pd.Pattern
		Dim x, y As Int
		Select orientation
			Case 0
				x = p(0)
				y = p(1)
			Case 1
				x = p(1)
				y = -p(0)
				
			Case 2
				x = -p(0)
				y = -p(1)
			Case 3
				x = -p(1)
				y = p(0)
		End Select
		FillBlock(pd.CenterX + x, pd.CenterY + y)
		blocks.Add(Array As Int(x, y))
	Next
End Sub

Private Sub FillBlock (x As Int, y As Int)
	MySprite.Frame.DrawBitmapCreator(pd.BlockBC, pd.BlockBC.TargetRect, x * BlockSize, y * BlockSize, True)
	
End Sub